Subject: Additional orientation-related functions for Image

Description

Hi guys,

| would like to improve the image handling of the TYPO3.Media package; | like it very much so far.

When working on it, | figured out some things that could be improved, | think or hope.

At first | added a few functions to the Image class, could be backed also into the interface (see attached patches).

In general, | would suggest a bit another approach of the ImageVariant: at first | say it should be extended from Image, because an
image variant mostly has the properties of an Image (which is inherently correct :)

This ImageVariant class then has only an additional property $originallmage which is set during construction. All other properties and
methods are interited anyway, and that's correct.

Then | say an Image Variant should not be "created" or "transformed" during creation (i.e. within the constructor), but be more a
"base" for working on an image variant. So | would suggest something like this (pseudo-code):

class ImageVariant extends Image {
Je
* @var \TYPO3\Media\Domain\Model\lmage
*/
protected $originallmage;

e
* @param Image $baselmage The Image that image variant is based on
*/
public function __construct(\TYPO3\Media\Domain\Model\image $baselmage) {
$this->originallmage = $baselmage;
$this->width = $baselmage->getWidth();
$this->height = $baselmage->getHeight();

and than one could do the following:

$myThumbnail = new ImageVariant();
$myThumbnail->setWidth(180)->preserveAspectRatio(true)->cropToSquare()->getResource();

each mentioned function is set in the ImageVariant and returns $this itself. Also each function just modyfies private properties; and
with e.g. getResource() or any other 'build()' function (even __toString() is possible) the image is finally built.
What do you think?

Associated revisions

Revision 94273784 - 2012-01-31 16:21 - Adrian Foder

[FEATURE] Additional orientation-related functions for Image

Providing functions to get information about the orientation of the image.
Change-Id: 126f8dcf8d0abc9051f63185853b503fed7dd0ab7

Related: #31334

History

#1 - 2011-10-27 10:54 - Adrian Féder
- File 0001-Related-31334.patch added

#2 - 2012-01-24 15:52 - Adrian Foéder

see https://review.typo3.org/#change,6870 Patch is obsolete.

#3 - 2012-02-01 12:30 - Bastian Waidelich

- Subject changed from Making ImageVariant more object orientated to Additional orientation-related functions for Image
- Status changed from New to Resolved

- Assigned To set to Bastian Waidelich

- % Done changed from 0 to 100

Files

0001-Related-31334.patch 4 kB 2011-10-27 Adrian Foder

2015-08-03 22


https://review.typo3.org/#change,6870

